"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var querystring_1 = require("querystring");
require('es6-promise').polyfill();
require('isomorphic-fetch');
var getChallenge = function (address, sigObj) { return __awaiter(_this, void 0, void 0, function () {
    var _this = this;
    var url;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                url = 'http://localhost:3001/token?' +
                    querystring_1.default.stringify({
                        method: 'challenge',
                        address: address,
                        message_raw: sigObj.messageBufferHex,
                        message_hex: sigObj.messageHex,
                        message_signature: sigObj.signature,
                    });
                return [4 /*yield*/, fetch(url).then(function (response) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (response.status >= 400) {
                                        throw new Error('Bad response from server');
                                    }
                                    return [4 /*yield*/, response.json()];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        });
                    }); })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
var getToken = function (address, signedChallange) { return __awaiter(_this, void 0, void 0, function () {
    var _this = this;
    var url;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                url = 'http://localhost:3001/token?' +
                    querystring_1.default.stringify({
                        method: 'verify',
                        address: address,
                        message_raw: signedChallange.messageBufferHex,
                        message_hex: signedChallange.messageHex,
                        message_signature: signedChallange.signature,
                    });
                return [4 /*yield*/, fetch(url).then(function (response) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (response.status >= 400) {
                                        throw new Error('Bad response from server');
                                    }
                                    return [4 /*yield*/, response.json()];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        });
                    }); })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
var Firebase = /** @class */ (function () {
    function Firebase(framework) {
        this.framework = framework;
    }
    Firebase.prototype.login = function () {
        return __awaiter(this, void 0, void 0, function () {
            var T, accounts, address, sigObj, challengeResponse, signedChallengeMessageRaw, signedChallange, tokenResponse;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        T = this.framework;
                        return [4 /*yield*/, T.getAccounts()];
                    case 1:
                        accounts = _a.sent();
                        address = accounts[0];
                        return [4 /*yield*/, T.Toolbox.sign(address, 'transmute.framework.login')
                            // console.log(sigObj)
                        ];
                    case 2:
                        sigObj = _a.sent();
                        return [4 /*yield*/, getChallenge(address, sigObj)];
                    case 3:
                        challengeResponse = _a.sent();
                        if (challengeResponse.status !== 200) {
                            throw Error(challengeResponse);
                        }
                        if (!challengeResponse.body.conditions.didClientAddressSignMessageRaw) {
                            throw Error('Server does not trust signature. didClientAddressSignMessageRaw: false');
                        }
                        signedChallengeMessageRaw = challengeResponse.body.challenge;
                        return [4 /*yield*/, T.Toolbox.sign(address, signedChallengeMessageRaw)];
                    case 4:
                        signedChallange = _a.sent();
                        return [4 /*yield*/, getToken(address, signedChallange)];
                    case 5:
                        tokenResponse = _a.sent();
                        return [4 /*yield*/, this.framework.firebaseApp
                                .auth()
                                .signInWithCustomToken(tokenResponse.body.token)
                                .then(function (data) {
                                if (data.uid === address) {
                                    console.log('🏡  Logged in as:', address);
                                }
                            })
                                .catch(function (error) {
                                throw error;
                            })];
                    case 6: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Firebase.prototype.logout = function () {
        console.log('logout..');
    };
    return Firebase;
}());
exports.default = Firebase;
//# sourceMappingURL=Firebase.js.map